/**
 * Generated by @thi.ng/wasm-api-bindgen at 2024-08-17T16:17:33.284Z
 * DO NOT EDIT!
 */
import { WasmStringPtr, type WasmTypeBase, type WasmTypeConstructor } from "@thi.ng/wasm-api";
import type { GLType as ModelAttribType } from "@thi.ng/api";
import type { DrawMode, TextureFilter, TextureFormat, TextureRepeat, TextureTarget, TextureType } from "@thi.ng/webgl";
/**
 * WebGL rendering context options, used by `createCanvasContext()`
 */
export interface WebGLContextOpts extends WasmTypeBase {
    /**
     * Zig type: `u8`
     */
    readonly alpha: number;
    /**
     * Zig type: `u8`
     */
    readonly antialias: number;
    /**
     * Zig type: `u8`
     */
    readonly depth: number;
    /**
     * Zig type: `u8`
     */
    readonly desynchronized: number;
    /**
     * Zig type: `u8`
     */
    readonly failIfMajorPerformanceCaveat: number;
    readonly powerPreference: WebGLPowerPreference;
    /**
     * Zig type: `u8`
     */
    readonly premultipliedAlpha: number;
    /**
     * Zig type: `u8`
     */
    readonly preserveDrawingBuffer: number;
    /**
     * Zig type: `u8`
     */
    readonly stencil: number;
}
export declare const $WebGLContextOpts: WasmTypeConstructor<WebGLContextOpts>;
export declare enum WebGLPowerPreference {
    default = 0,
    high_performance = 1,
    low_power = 2
}
export interface ShaderSpec extends WasmTypeBase {
    readonly vs: WasmStringPtr;
    readonly fs: WasmStringPtr;
    /**
     * Slice of shader attribute specs
     */
    readonly attribs: ShaderAttribSpec[];
    /**
     * Slice of shader varying specs
     */
    readonly varying: ShaderVaryingSpec[];
    /**
     * Slice of shader uniform specs
     */
    readonly uniforms: ShaderUniformSpec[];
}
export declare const $ShaderSpec: WasmTypeConstructor<ShaderSpec>;
export interface ShaderAttribSpec extends WasmTypeBase {
    readonly name: WasmStringPtr;
    readonly type: ShaderAttribType;
}
export declare const $ShaderAttribSpec: WasmTypeConstructor<ShaderAttribSpec>;
export interface ShaderVaryingSpec extends WasmTypeBase {
    readonly name: WasmStringPtr;
    readonly type: ShaderAttribType;
}
export declare const $ShaderVaryingSpec: WasmTypeConstructor<ShaderVaryingSpec>;
export interface ShaderUniformSpec extends WasmTypeBase {
    readonly name: WasmStringPtr;
    readonly type: UniformType;
    readonly default: UniformValue;
}
export declare const $ShaderUniformSpec: WasmTypeConstructor<ShaderUniformSpec>;
export interface ModelSpec extends WasmTypeBase {
    /**
     * Slice of model attribute specs
     */
    readonly attribs: ModelAttribSpec[];
    /**
     * Slice of instance attribute specs
     */
    readonly instances: ModelAttribSpec[];
    /**
     * Slice of model uniforms
     */
    readonly uniforms: ModelUniform[];
    /**
     * Zig type: `ConstI32Slice`
     */
    readonly textures: Int32Array;
    /**
     * Zig type: `i32`
     */
    readonly shader: number;
    /**
     * Zig type: `u32`
     */
    readonly num: number;
    /**
     * Zig type: `u32`
     */
    readonly numInstances: number;
    readonly mode: DrawMode;
}
export declare const $ModelSpec: WasmTypeConstructor<ModelSpec>;
export interface ModelAttribSpec extends WasmTypeBase {
    readonly name: WasmStringPtr;
    readonly data: ModelAttribData;
    readonly type: ModelAttribType;
    /**
     * Zig type: `u32`
     */
    readonly offset: number;
    /**
     * Zig type: `u32`
     */
    readonly stride: number;
    /**
     * Zig type: `u32`
     */
    readonly size: number;
}
export declare const $ModelAttribSpec: WasmTypeConstructor<ModelAttribSpec>;
export interface ModelAttribData extends WasmTypeBase {
    /**
     * Zig type: `ConstI8Slice`
     */
    readonly u8: Int8Array;
    /**
     * Zig type: `ConstU8Slice`
     */
    readonly i8: Uint8Array;
    /**
     * Zig type: `ConstI16Slice`
     */
    readonly i16: Int16Array;
    /**
     * Zig type: `ConstU16Slice`
     */
    readonly u16: Uint16Array;
    /**
     * Zig type: `ConstI32Slice`
     */
    readonly u32: Int32Array;
    /**
     * Zig type: `ConstU32Slice`
     */
    readonly i32: Uint32Array;
    /**
     * Zig type: `ConstF32Slice`
     */
    readonly f32: Float32Array;
}
export declare const $ModelAttribData: WasmTypeConstructor<ModelAttribData>;
export interface AttribUpdateSpec extends WasmTypeBase {
    readonly data: ModelAttribData;
    readonly type: ModelAttribType;
    /**
     * Start byte offset in WebGL buffer
     *
     * @remarks
     * Zig type: `u32`
     */
    readonly offset: number;
}
export declare const $AttribUpdateSpec: WasmTypeConstructor<AttribUpdateSpec>;
export interface ModelUniform extends WasmTypeBase {
    readonly name: WasmStringPtr;
    readonly type: UniformType;
    readonly value: UniformValue;
}
export declare const $ModelUniform: WasmTypeConstructor<ModelUniform>;
export interface UniformValue extends WasmTypeBase {
    /**
     * Zig type: `f32`
     */
    readonly float: number;
    /**
     * Zig type: `@Vector(2, f32)`
     */
    readonly vec2: Float32Array;
    /**
     * Zig type: `@Vector(3, f32)`
     */
    readonly vec3: Float32Array;
    /**
     * Zig type: `@Vector(4, f32)`
     */
    readonly vec4: Float32Array;
}
export declare const $UniformValue: WasmTypeConstructor<UniformValue>;
export interface TextureSpec extends WasmTypeBase {
    readonly img: ImageData;
    /**
     * Zig type: `u16`
     */
    readonly width: number;
    /**
     * Zig type: `u16`
     */
    readonly height: number;
    /**
     * Zig type: `u16`
     */
    readonly depth: number;
    readonly format: TextureFormat;
    readonly target: TextureTarget;
    readonly type: TextureType;
    readonly filter: TextureFilter;
    readonly wrap: TextureRepeat;
    readonly imgType: ImageType;
}
export declare const $TextureSpec: WasmTypeConstructor<TextureSpec>;
export interface ImageData extends WasmTypeBase {
    /**
     * Zig type: `u32`
     */
    readonly none: number;
    /**
     * Zig type: `ConstU8Slice`
     */
    readonly u8: Uint8Array;
    /**
     * Zig type: `ConstU16Slice`
     */
    readonly u16: Uint16Array;
    /**
     * Zig type: `ConstU32Slice`
     */
    readonly u32: Uint32Array;
    /**
     * Zig type: `ConstF32Slice`
     */
    readonly f32: Float32Array;
}
export declare const $ImageData: WasmTypeConstructor<ImageData>;
export declare enum ImageType {
    none = 0,
    u8 = 1,
    u16 = 2,
    u32 = 3,
    f32 = 4
}
export declare enum ShaderAttribType {
    float = 0,
    int = 1,
    uint = 2,
    vec2 = 3,
    vec3 = 4,
    vec4 = 5,
    mat22 = 6,
    mat33 = 7,
    mat44 = 8
}
export declare enum UniformType {
    float = 0,
    int = 1,
    uint = 2,
    vec2 = 3,
    vec3 = 4,
    vec4 = 5,
    mat22 = 6,
    mat33 = 7,
    mat44 = 8,
    sampler2D = 9,
    sampler3D = 10,
    samplerCube = 11
}
//# sourceMappingURL=api.d.ts.map